
/* MAI-SH4D32 SH7750R */
/* Start.asm */
/* big */

/*
(MD2,MD1,MD0)=(0,1,1)=3
SH7750R  CPU CLK     19.6608MHz x 12 = 235.9296MHz
         BUS CLKIO   19.6608MHz x  4 =  78.6432MHz                  
         IF          19.6608MHz x  2 =  39.3216MHz 
*/

//#define CPPAPP	


#SRAM_BUS32  0
#SDRAM_BUS32 1
#SDRAM_BUS64 0



#define BSC_INIT 0


#define CACHE_INIT 0
#define CACHE_ENABLE 1


#define ROMSTART 1
#define SH7750R 1
#define SDRAM 0

#define CLKIO_66 0
#define CLKIO_81 0
#define CLKIO_78_6432 1



	! Start.asm

	.list
	.section .text
	.global _start  ! global Start routine 

#ifdef CPPAPP	
___dso_handle:
	.global ___dso_handle
#endif		

	.extern _hw_initialise ! external Sub-routine to initialise Hardware
	.extern _main 
	.extern _data
	.extern _mdata
	.extern _edata
	.extern _ebss 
	.extern _bss
	.extern _stack

#if	DEBUG
	.extern _exit
#endif

_start:
	! initialise the SP for non-vectored code
	mov.l	stack,r15


!status-register initialised
//	mov #0xf0,r4
//	extu.b r4,r4
//	ldc r4,sr



#if BSC_INIT
/* Initialize BSC Modul */		
/* CS3 SDRAM  */
	mov.l	BCR1_Addres,r1
	mov.l	BCR1_CS3_SDRAM,r0
	//mov.l	BCR1_CS1BYTE_CS3_SDRAM,r0
	mov.l	r0,@r1


/* CS6,5,4:16bit,CS2:16bit,CS1:16bit    PORT EN=1 */
/* 10_10 10_10     11_10 10_01  */

	mov.l	BCR2_Addres,r1

	//mov.l	BCR2_R8S8,r0       /* FlashRom CS0  8bit ,SRAM  CS1 8bit  PORT EN=0 */

    //#if SRAM_BUS32
	//mov.l	BCR2_R8S32,r0      /* FlashRom CS0  8bit ,SRAM  CS1 32bit PORT EN=0 */
    //#endif //SRAM_BUS32


#if SDRAM_BUS32
	mov.l	BCR2_R16D32,r0     /* FlashRom CS0 16bit ,SDRAM CS3 32bit PORT EN=1 */
#endif //SDRAM_BUS32


#if SDRAM_BUS64
	mov.l BCR2_R16D64,r0       /* FlashRom CS0 16bit ,SDRAM CS3 64bit PORT EN=0 */
#endif //SDRAM_BUS64



	mov.w	r0,@r1

    /*BCR3  SH7750R  only */ 
    /*BCR4  SH7750R  only */ 

#if SH7750R
//	mov.l	BCR3_Addres,r1
//	mov.l	BCR3_Data,r0
//	mov.l	r0,@r1

//	mov.l	BCR4_Addres,r1
//	mov.l	BCR4_Data,r0
//	mov.l	r0,@r1
#endif


	mov.l	WCR1_Addres,r1
	mov.l	WCR1_Data,r0
	mov.l	r0,@r1

	mov.l	WCR2_Addres,r1
	mov.l	WCR2_Data,r0
	mov.l	r0,@r1

	mov.l	WCR3_Addres,r1

#if SH7750R
	mov.l	WCR3_Data_R,r0
#else
	mov.l	WCR3_Data,r0
#endif
	mov.l	r0,@r1

#endif  //BSC_INIT




#if SDRAM
	/* Refresh Time Const Reg  */
	/* SDRAM Refresh Time 15.6us */
	/* 4125KHz/64   =64.5KHz    1/64.5KHz=15.5us  */
	/* 4050KHz/63   =64.28KHz   1/64.28KHz=15.5us  */
	/* 3932.16KHz/61=64.46KHz   1/64.46KHz=15.5us  */

	mov.l	RTCOR_Addres,r1

#if CLKIO_66	
	mov.l	RTCOR_Data40,r0
#endif
	
#if CLKIO_81	
	mov.l	RTCOR_Data3F,r0
#endif

#if CLKIO_78_6432
	mov.l	RTCOR_Data3D,r0
#endif



	mov.w	r0,@r1

    /* Refresh Timer Control / Status Reg */ 
    /* Refresh CLK enable */
	/* CKIO/16=66MHz/16=4.125MHz=4125KHz   */
	/* CKIO/16=81MHz/20=4.050MHz=4050KHz   */
	/* CKIO/16=78.6432/20=3.93216MHz=3932.16KHz   */

	mov.l	RTCSR_Addres,r1


#if CLKIO_66	
	mov.l	RTCSR_Data10,r0    
#endif
	
#if CLKIO_81	
	mov.l	RTCSR_Data14,r0    
#endif

#if CLKIO_78_6432
	mov.l	RTCSR_Data14,r0    
#endif

	mov.w	r0,@r1


    /* Memory Control Reg */
	mov.l	MCR_Addres,r1
	mov.l	MCR_Data1,r0
	mov.l	r0,@r1

#if SDRAM_BUS32
	mov.l	SDMR3_A32,r1	/* Set SDRAM mode */
#endif //SDRAM_BUS32

#if SDRAM_BUS64
	mov.l	SDMR3_A64,r1	/* Set SDRAM mode */
#endif //SDRAM_BUS64


	mov	#0,r0
	mov.b	r0,@r1



	/* Wait DRAM refresh 30 times */
	mov.l	RFCR_Addres,r1
	mov.l	RFCR_Data,r0
	mov.w	r0,@r1		/* Clear reflesh counter */


	mov	#30,r3
refresh30:
	mov.w	@r1,r0
	extu.w	r0,r2
	cmp/hi	r3,r2
	bf	 refresh30
	nop


	mov.l	MCR_Addres,r1
	mov.l	MCR_Data2,r0	/* MRSET=1*/
	mov.l	r0,@r1

	/* Set SDRAM mode */
	
#if SDRAM_BUS32
	mov.l	SDMR3_A32,r1
#endif //SDRAM_BUS32

	
#if SDRAM_BUS64
	mov.l	SDMR3_A64,r1
#endif //SDRAM_BUS64

	mov	#0,r0
	mov.b	r0,@r1

#endif  //SDRAM


/* Initialize VBR */
	mov.l	VBR_INIT,r0
	ldc		r0,vbr





// SRݒ WX^oN1 -> WX^oN0ɕύX
// MD=1  [h 
// RB=0  WX^oN0  
// BL=1  O(荞݂)֎~

// d荞݂Ȃꍇ͊荞ݏ̓WX^oN1gp̂
// WX^R0`R7X^bN֑ޔKvȂ

	//p[IresetɂMD=1 RB=1 BL=1  WX^oN1 荞݋֎~  荞݃x15 
    //SR̐ݒ RB=0;
	stc		sr,r0			//r0<=sr	
	mov.l	RBclrSR,r2      //r2<=RBclrSR
	and		r2,r0			//r0<=r0 and r2	
	ldc		r0,sr           //sr<=r0
	//SR̐ݒɂ       MD=1 RB=0 BL=1  WX^oN0  荞݋֎~ 荞݃x15 



#if CACHE_INIT
//ccr_set:
	/* ENABLE cache */
	mov.l	CCR_Addres, r1
#if CACHE_ENABLE
	mov.l	CCR_ENABLE,r0
#else
	mov.l	CCR_DISABLE,r0
#endif
	mov.l	r0, @r1

#endif //CACHE_INIT



	nop
	nop
	nop
	nop
	
	nop
	nop
	nop
	nop
	
	nop
	nop
	nop
	nop
	
	nop
	nop
	nop
	nop


! Call the hardware initialiser
	mov.l	hw_initialise,r1
	jsr     @r1
	nop



!load data section from ROM to RAM only if ROMSTART is defined

//lt̃O[oϐɏlZbg

#if ROMSTART
	! initialise sections
	mov.l	edata,r1		! edata in r1
	mov.l	mdata,r2		! mdata in r2
	mov.l	data,r0		    ! data in r0
	cmp/eq  r0,r1
	bt	start_1
	nop
start_l:
	mov.b   @r2,r3  !get from src
	mov.b   r3,@r0  !place in dest
	add   	#1,r2    !inc src
	add   	#1,r0    !inc dest
	cmp/eq  r0,r1   !dest == edata?
	bf	start_l
	nop
start_1:
#endif // ROMSTART


//lȂ̃O[oϐɃ[Zbg

	! zero out bss
	mov.l	ebss,r1
	mov.l	bss,r0
	cmp/eq	r0,r1         
	bt	start_3
	sub	r2,r2
start_2:
	mov.b	r2,@r0
	add	#1,r0
	cmp/eq	r0,r1
	bf     	start_2
	nop
start_3:

#ifdef CPPAPP	
	!Initialize global constructor	
	mov.l	_InitCtors,r1
	jsr     @r1
	nop
#endif

	mov.l	main,r1
	jsr     @r1
	nop
	
	! call to exit
#if DEBUG
	mov.l	_exit_k,r1
	jsr	@r1
	nop
#endif

#if RELEASE
exit:
	bra 	exit
	nop
#endif




	.ALIGN 4
hw_initialise:	
		.long	_hw_initialise
stack:
		.long	_stack
main:
		.long	_main

#ifdef CPPAPP	
_InitCtors:
		.long	___main
#endif	

data:
		.long	_data
mdata:
		.long	_mdata
edata:
		.long	_edata
bss:
		.long	_bss
ebss:
		.long	_ebss
#if DEBUG
_exit_k:
		.long   _exit
#endif


CCR_Addres:			.long	0xff00001c      /* CCR Address */

/* CCR    IIX_15   ICI_11  ICE_8     OIX_7 ORA_5 OCI_3 CB_2 WT_1 OCE_0  */
/*            0000   000______1        00___10      0___0___1_____1     */ 
/*  EMODE_31 IIX_15 ICI_11 ICE_8     OIX7 ORA_5 OCI_3 CB_2 WT_1 OCE_0 */ 
/*  E000 0000 0000 0000    I000 I00I o0o0 oCwo */
/*  0000 0000 0000 0000    0000 1000 0000 1000 = 0x00000808 */
/* ICI_11=1 OCI_3=1 */
/*  0000 0000 0000 0000    0000 0001 0010 0011 = 0x00000123 */ 
/* ICE_8=1 ORA_5=1 WT_1=1 OCE_0=1  */

/*  1000 0000 0000 0000    0000 0001 0010 0011 = 0x80000123 */ 
/* EMODE_31=1 ICE_8=1 ORA_5=1 WT_1=1 OCE_0=1  */




#if SH7750R
CCR_ENABLE:		.long	0x80000123   //EMODE=1 RAM ENABLE
CCR_DISABLE:	.long	0x80000829   //EMODE=1 RAM ENABLE
#else
CCR_ENABLE:		.long	0x00000123   //EMODE=0 RAM ENABLE
CCR_DISABLE:	.long	0x00000829   //EMODE=0 RAM ENABLE
#endif





/* Bus control register1 */
BCR1_Addres:			.long	0xFF800000	/* BCR1 Address */

/* CS2_3 SDRAM */
/* 0000 0000 0000 0000 : 0000 0000 0000 1100 */
//BCR1_CS2_3_SDRAM: .long	0x0000000C	

/* CS3 SDRAM */
/* 0000 0000 0000 0000 : 0000 0000 0000 1000 */
BCR1_CS3_SDRAM: .long	0x00000008	


/* CS1oCgSRAM */
/* 0000 0000 0010 0000 : 0000 0000 0000 1000 */
//BCR1_CS1BYTE_CS3_SDRAM: .long	0x00200008	



/* Bus control register2 */
BCR2_Addres:			.long	0xFF800004	/* BCR2 Address */

				/* CS0,6,5,4:8bit,CS3,2:32bit,CS1:8bit   PORT EN=0 */
				/* 0101 0101 1111 0100  */
                //BCR2_SMP:    	.long	0x55F4		

/* CS0,6,5,4:16bit,CS3:32bit,CS2:16bit,CS1:16bit    PORT EN=1 */
/* 10_10 10_10     11_10 10_01  */
#if SDRAM_BUS32
BCR2_R16D32:    	.long	0xAAE9		
#endif //SDRAM_BUS32


/* CS0,6,5,4:16bit,CS3:64bit,CS2:16bit,CS1:16bit    PORT EN=0 */
/* 10_10 10_10     00_10 10_00  */
#if SDRAM_BUS64
BCR2_R16D64:    	.long	0xAA28		
#endif //SDRAM_BUS64



/* Wait control register1 */
WCR1_Addres:			.long	0xFF800008	/* WCR1 Address */
				/* 0111 0111 0111 0111 : 0111 0111 0111 0111  */
				/* 0111 0111 0111 0111 : 0001 0111 0111 0111  */
				/* DMA  CS6  CS5  CS4    CS3  CS2  CS1  CS0   */
//WCR1_Data:		.long	0x77777777
//WCR1_Data:		.long	0x77771777
WCR1_Data:			.long	0x77770711    /*AChTCN CS3=0,CS1=1,CS0=1 */


/* Wait control register2 */
WCR2_Addres:			.long	0xFF80000C	/* WCR2 Address */
				/* 111 1:11 11:1 11:1 111 0 : 111 0: 111  1:11 11:1  111  */
				/* 111 1:11 11:1 11:1 111 0 : 010 0: 111  1:11 11:1  111  */
				/* A6W A6B  A5W  A5B  A4W     A3W    A2W  A1W  A0W   A0B  */


//WCR2_Data:			.long	0xFFFEEFFF
//WCR2_Data:			.long	0xFFFE4FFF
WCR2_Data:			.long	0xFFFE4F20       //CS3=CeV2  CS1=6Wait  CS0=6Wait






/* Wait control register3 */
WCR3_Addres:			.long	0xFF800010	/* WCR3 Address */

#if SH7750R
				/* 0000 0111 0111 0111 : 0111 0111 0111 0111 */
				/* 0000 0111 0111 0111 : 0101 0111 0111 0111 */
                /*        A6   A5   A4     A3   A2   A1   A0 */
//WCR3_Data_R:		.long	0x07777777
//WCR3_Data_R:		.long	0x07775777
WCR3_Data_R:		.long	0x07775755     //

#else
				/* 0000 0111 0111 0111 : 0111 0111 0111 0111 */
				/* 0000 0111 0111 0111 : 0101 0111 0111 0111 */
                /*        A6   A5   A4     A3   A2   A1   A0 */
//WCR3_Data:		.long	0x07777777
WCR3_Data:			.long	0x07775777


#endif

				/* Reflash Time 15.6us */
				/* CKIO=66MHz          */
                /* 66MHz/RTCSR_D10(16)=4.125MHz=4125KHz */
                /* 4125KHz/RTCOR_D40(64)=64.5KHz    1/64.5KHz=15.5us */
RTCSR_Addres:		.long	0xFF80001C	/* RTCSR Address */
RTCSR_Data10:		.long	0xA510		/* RTCSR Write Code A5h Data 10h(16) */
RTCSR_Data14:		.long	0xA514		/* RTCSR Write Code A5h Data 14h(20) */


RTCOR_Addres:		.long	0xFF800024	/* RTCOR Address */
RTCOR_Data40:		.long	0xA540		/* RTCOR Write Code A5h Data 40h(64) */
RTCOR_Data3F:		.long	0xA53F		/* RTCOR Write Code A5h Data 3Fh(63) */
RTCOR_Data3D:		.long	0xA53D		/* RTCOR Write Code A5h Data 3Dh(61) */


#if SDRAM_BUS32
SDMR3_A32:		.long	0xFF94008c	/*CS3 32bit  SDMR3 Address  BL8 CAS2 */
#endif //SDRAM_BUS32


#if SDRAM_BUS64
SDMR3_A64:		.long	0xFF940110  /*CS3 64bit  SDMR3 Address  BL4 CAS2 */
#endif //SDRAM_BUS64




MCR_Addres:			.long	0xFF800014	/* MCR Address */

				/* 0001 1000 0000 1001 : 0100 0001 1001 0100 AMX 2  32bit 0x18094194 */
				/* 0001 1000 0000 1001 : 0100 0001 1010 0100 AMX 4  32bit 0x180941A4 */
				/* 0001 1000 0000 1001 : 0100 0000 0010 0100 AMX 4  64bit 0x18094024 */

                /* Bit31       0 RAS NOMAL */
                /* Bit30       0 ALL Pre Charge */
                /* Bit29,28,27 011 RAS Pre Charge 9 */
                /* Bit26,25,24 000  */
                /* Bit23  0 CAS NeGate 1 */
                /* Bit22  0 */
                /* Bit21,20,19 001 TPC2_0  SDRAM PreCharge 2 */
                /* Bit18  0 */
                /* Bit17,16 01 RAS_CAS Delay 2Cy  */

                /* Bit15,14,13 010 TRWL Write PreCharge Delay 3 */
                /* Bit12,11,10 000 TRAS 4+TRC */
                /* Bit9  0 Busto Enable */
					/* Bit8,7 11 Memory Data Size 32Bit */
				/* Bit8,7 00 Memory Data Size 64Bit */
				   /* Bit6,5,4,3  0 010   AMXEXT 0 AMX 2  (64M:1M x 16bit x 4)x 2  */
				   /* Bit6,5,4,3  0 100   AMXEXT 0 AMX 4  (64M:512k x 32bit x 4) x 1  */
				/* Bit6,5,4,3  0 100   AMXEXT 0 AMX 4  (64M:512k x 32bit x 4) x 2  */

				/* Bit2 1 Refresh ON */  
                /* Bit1 0 CAS Before RAS Refresh */
                /* Bit0 0  EDO MODE off */ 



//MCR_Data1:		.long	0x18094194	/* MRSET:'0' */
//MCR_Data1:		.long	0x180941A4	/* MRSET:'0' 32bit AMX4 */
MCR_Data1:			.long	0x18094024	/* MRSET:'0' 64bit AMX4 */


//MCR_Data2:		.long	0x58094194	/* MRSET:'1' */
//MCR_Data2:		.long	0x580941A4	/* MRSET:'1' 32bit AMX4 */
MCR_Data2:			.long	0x58094024	/* MRSET:'1' 64bit AMX4 */

RFCR_Addres:		.long	0xFF800028	/* RFCR Address */
RFCR_Data:			.long	0xA400		/* RFCR Write Code A4h Data 00h */



VBR_INIT:		.long   _ResetHandler
RBclrSR:        .long	0x5FFFFFFF   /* bit30:MD=1, bit29:RB=0, bit28:BL=1 */



.end
