/****************************************************************
KPIT Cummins Infosystems Ltd, Pune, India. - 05-Sept-2005.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*****************************************************************/

#include "inthandler.h"

#include "tmu0.h"



extern void start (void);     /* Startup code (in start.s)  */

/**----------------------------------
**  Typedef for the function pointer
**-----------------------------------*/

typedef void (*fp) (void);

const fp Exp_Vectors[] = {
start,                      /*H'000  Power-on reset, Program counter (PC) */
INT_Manual_Reset,           /*H'020 */  
INT_TLBMiss_Load,			/*H'040 TLB miss/invalid (load)*/
INT_TLBMiss_Store,			/*H'060 TLB miss/invalid (store)*/
INT_TLBInitial_Page,		/*H'080 Initial page write*/
INT_TLBProtect_Load,		/*H'0A0 TLB protect (load)*/
INT_TLBProtect_Store,		/*H'0C0 TLB protect (store)*/
INT_Address_load,			/*H'0E0 Address error (load)*/
INT_Address_store,			/*H'100 Address error (store)*/
(fp)0,			 /*Reserved 1|H'120 Reserved*/
(fp)0,			 /*Reserved 2|H'140 Reserved*/
INT_TRAPA,			        /*H'160 TRAPA*/
INT_Illegal_code,			/*H'180 Illegal code*/
INT_Illegal_slot,			/*H'1A0 Illegal slot*/
INT_NMI,			        /*H'1C0 Nonmaskable interrupt*/
INT_User_Break,		     	/*H'1E0 User breakpoint trap*/
INT_Extern_0000,			/*H'200 External hardware interrupt*/
INT_Extern_0001,			/*H'220 External hardware interrupt*/
INT_Extern_0010,			/*H'240 External hardware interrupt*/
INT_Extern_0011,			/*H'260 External hardware interrupt*/
INT_Extern_0100,			/*H'280 External hardware interrupt*/
INT_Extern_0101,			/*H'2A0 External hardware interrupt*/
INT_Extern_0110,			/*H'2C0 External hardware interrupt*/
INT_Extern_0111,			/*H'2E0 External hardware interrupt*/
INT_Extern_1000,			/*H'300 External hardware interrupt*/
INT_Extern_1001,			/*H'320 External hardware interrupt*/
INT_Extern_1010,			/*H'340 External hardware interrupt*/
INT_Extern_1011,			/*H'360 External hardware interrupt*/
INT_Extern_1100,			/*H'380 External hardware interrupt*/
INT_Extern_1101,			/*H'3A0 External hardware interrupt*/
INT_Extern_1110,			/*H'3C0 External hardware interrupt*/
(fp)0,		         /*Reserved 3E0|H'3E0 Reserved*/
intrpt_tmu0,	     /*Reserved 400|H'400 Reserved*/
(fp)0,		         /*Reserved 420|H'420 Reserved*/
(fp)0,			     /*Reserved 440|H'440 Reserved*/
(fp)0,			     /*Reserved 460|H'460 Reserved*/
(fp)0,			     /*Reserved 480|H'480 Reserved*/
(fp)0,			     /*Reserved 4A0|H'4A0 Reserved*/
(fp)0,			     /*Reserved 4C0|H'4C0 Reserved*/
(fp)0,			/*Reserved 4E0|H'4E0 Reserved*/
(fp)0,			/*Reserved 500|H'500 Reserved*/
(fp)0,			/*Reserved 520|H'520 Reserved*/
(fp)0,			/*Reserved 540|H'540 Reserved*/
(fp)0,			/*Reserved 560|H'560 Reserved*/
(fp)0,			/*Reserved 580|H'580 Reserved*/
(fp)0,			/*Reserved 5A0|H'5A0 Reserved*/
INT_DMA_ADERR,			/*H'5C0 DMA address error*/
INT_HUDI,			/*H'5E0 H-UDI interrupt*/
INT_IRQ0,			/*H'600 IRQ0*/
INT_IRQ1,			/*H'620 IRQ1*/
INT_IRQ2,			/*H'640 IRQ2*/
INT_IRQ3,			/*H'660 IRQ3*/
INT_IRQ4,			/*H'680 IRQ4*/
INT_IRQ5,			/*H'6A0 IRQ5*/
(fp)0,			/*Reserved 6C0|H'6C0 Reserved*/
(fp)0,			/*Reserved 6E0|H'6E0 Reserved*/
INT_PINT0_7,			/*H'700 PINT0_7*/
INT_PINT8_15,			/*H'720 PINT8_15*/
(fp)0,			/*Reserved 740|H'740 Reserved*/
(fp)0,			/*Reserved 760|H'760 Reserved*/
INT_DMAC_DMTE4,			/*H'780 DMAC DMTE4*/
INT_DMAC_DMTE5,			/*H'7A0 DMAC DMTE5*/
INT_DMAC_DMTE6,			/*H'7C0 DMAC DMTE6*/
INT_DMAC_DMTE7,			/*H'7E0 DMAC DMTE7*/
INT_Illegal_FPU,			/*H'800 Illegal FPU*/
INT_Illegal_slot_FPU,			/*H'820 Illegal slot FPU*/
};
